diff --git a/meta/conf/distro/debian-bookworm.conf b/meta/conf/distro/debian-bookworm.conf
index ce7279e3..ee8f2ced 100644
--- a/meta/conf/distro/debian-bookworm.conf
+++ b/meta/conf/distro/debian-bookworm.conf
@@ -7,12 +7,10 @@ BASE_DISTRO_CODENAME = "bookworm"
 HOST_DISTRO ?= "debian-${BASE_DISTRO_CODENAME}"
 
 DISTRO_CONFIG_SCRIPT ?= "debian-configscript.sh"
-DISTRO_KERNELS ?= "4kc-malta 5kc-malta 686-pae 686 alpha-generic alpha-smp \
-	amd64 arm64 armmp-lpae armmp cloud-amd64 cloud-arm64 itanium \
-	loongson-3 m68k marvell mckinley mips32r6 mips32r6el mips64r6 \
-	mips64r6el octeon parisc parisc64 powerpc-smp powerpc powerpc64 \
-	powerpc64le riscv64 rpi rt-686-pae rt-amd64 rt-arm64 rt-armmp \
-	s390x sh7751r sh7785lcr sparc64-smp sparc64"
+DISTRO_KERNELS ?= "4kc-malta 5kc-malta 686 686-pae amd64 arm64 armmp \
+        armmp-lpae cloud-amd64 cloud-arm64 loongson-3 marvell mips32r2el \
+        mips64r2el octeon powerpc64le rpi rt-686-pae rt-amd64 rt-arm64 \
+        rt-armmp s390x"
 
 DISTRO_GCC = "12"
 
diff --git a/meta/conf/distro/debian-bullseye.conf b/meta/conf/distro/debian-bullseye.conf
index 2cb9d20e..8b76c2ec 100644
--- a/meta/conf/distro/debian-bullseye.conf
+++ b/meta/conf/distro/debian-bullseye.conf
@@ -8,8 +8,8 @@ HOST_DISTRO ?= "debian-${BASE_DISTRO_CODENAME}"
 
 DISTRO_CONFIG_SCRIPT ?= "debian-configscript.sh"
 DISTRO_KERNELS ?= "4kc-malta 5kc-malta 686 686-pae amd64 arm64 armmp \
-    armmp-lpae cloud-amd64 loongson-3 octeon powerpc64le rpi s390x marvell \
-    rt-686-pae rt-amd64 rt-arm64 rt-armmp"
+        armmp-lpae cloud-amd64 cloud-arm64 loongson-3 marvell octeon \
+        powerpc64le rpi rt-686-pae rt-amd64 rt-arm64 rt-armmp s390x"
 
 DISTRO_GCC = "10"
 
diff --git a/meta/conf/distro/debian-buster.conf b/meta/conf/distro/debian-buster.conf
index 57cfac33..cd58710b 100644
--- a/meta/conf/distro/debian-buster.conf
+++ b/meta/conf/distro/debian-buster.conf
@@ -7,9 +7,8 @@ BASE_DISTRO_CODENAME = "buster"
 HOST_DISTRO ?= "debian-buster"
 
 DISTRO_CONFIG_SCRIPT ?= "debian-configscript.sh"
-DISTRO_KERNELS ?= "4kc-malta 5kc-malta 686 686-pae amd64 arm64 armmp \
-    armmp-lpae cloud-amd64 loongson-3 marvell octeon powerpc64le rpi s390x \
-    rt-686-pae rt-amd64 rt-arm64 rt-armmp"
+DISTRO_KERNELS ?= "686 686-pae amd64 arm64 armmp armmp-lpae cloud-amd64 \
+        rt-686-pae rt-amd64 rt-arm64 rt-armmp"
 
 DISTRO_GCC = "8"
 
diff --git a/meta/conf/distro/debian-sid.conf b/meta/conf/distro/debian-sid.conf
index fdf9775c..081ec7b4 100644
--- a/meta/conf/distro/debian-sid.conf
+++ b/meta/conf/distro/debian-sid.conf
@@ -11,12 +11,11 @@ BASE_DISTRO_CODENAME = "sid"
 HOST_DISTRO ?= "debian-${BASE_DISTRO_CODENAME}"
 
 DISTRO_CONFIG_SCRIPT ?= "debian-configscript.sh"
-DISTRO_KERNELS ?= "4kc-malta 5kc-malta 686-pae 686 alpha-generic alpha-smp \
-	amd64 arm64 armmp-lpae armmp cloud-amd64 cloud-arm64 itanium \
-	loongson-3 m68k marvell mckinley mips32r6 mips32r6el mips64r6 \
-	mips64r6el octeon parisc parisc64 powerpc-smp powerpc powerpc64 \
-	powerpc64le riscv64 rpi rt-686-pae rt-amd64 rt-arm64 rt-armmp \
-	s390x sh7751r sh7785lcr sparc64-smp sparc64"
+DISTRO_KERNELS ?= "5kc-malta 686 686-pae alpha-generic alpha-smp amd64 arm64 \
+        armmp armmp-lpae cloud-amd64 cloud-arm64 itanium loongson-3 m68k \
+        mckinley mips64r2el mips64r6el octeon parisc parisc64 powerpc64 \
+        powerpc64-64k powerpc64le powerpc64le-64k riscv64 rpi rt-686-pae \
+        rt-amd64 rt-arm64 rt-armmp s390x sh7751r sh7785lcr sparc64 sparc64-smp"
 
 DISTRO_GCC = "13"
 
diff --git a/meta/conf/distro/debian-trixie.conf b/meta/conf/distro/debian-trixie.conf
index 2df4f827..d09cdfd3 100644
--- a/meta/conf/distro/debian-trixie.conf
+++ b/meta/conf/distro/debian-trixie.conf
@@ -10,9 +10,9 @@ BASE_DISTRO_CODENAME = "trixie"
 HOST_DISTRO ?= "debian-${BASE_DISTRO_CODENAME}"
 
 DISTRO_CONFIG_SCRIPT ?= "debian-configscript.sh"
-DISTRO_KERNELS ?= "5kc-malta 686 686-pae amd64 arm64 armmp armmp-lpae \
-        cloud-amd64 cloud-arm64 loongson-3 mips64r2el octeon powerpc64le \
-        riscv64 rpi rt-686-pae rt-amd64 rt-arm64 rt-armmp s390x"
+DISTRO_KERNELS ?= "5kc-malta amd64 arm64 armmp armmp-lpae cloud-amd64 \
+        cloud-arm64 loongson-3 mips64r2el mips64r6el octeon powerpc64le \
+        powerpc64le-64k riscv64 rpi rt-amd64 rt-arm64 rt-armmp s390x"
 
 DISTRO_GCC = "13"
 